% https://www.cs.utexas.edu/users/EWD/transcriptions/EWD05xx/EWD578.html

fusc(N,F) :- N=:=0, F=:=0.
fusc(N,F) :- N=:=1, F=:=1.
fusc(N,F)  :- N>=2, N=K+K,   fusc(K,F).                                  % even(N)  
fusc(N,F2) :- N>=2, N=K+K+1, fusc(K,F), K1=K+1, fusc(K1,F1), F2=F+F1.  %  odd(N) 


fuscit(N,F) :- X=:=N, A=:=1, B=:=0, B2=:=F, fuscit2(X,A,B,_,_,B2).
fuscit2(X,A,B, X2,A2,B2) :- X>=1, X=:=2*K,    A1=:=A+B, B1=:=B,   fuscit2(K,A1,B1, X2,A2,B2). 
fuscit2(X,A,B, X2,A2,B2) :- X>=1, X=:=2*K+1,  B1=:=A+B, A1=:=A,   fuscit2(K,A1,B1, X2,A2,B2). 


incorrect :-  N=:=N1, fusc(N,F), fuscit(N1,F1),  F=\=F1.


verimap(pred_smtvars_types([incorrect,fusc('Int','Int'),
			fuscit('Int','Int'),
			fuscit2('Int','Int','Int','Int','Int','Int')])).
			

